#include "bind.h"
#include "ref.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>

using namespace std;
using namespace nonstd;

namespace
{
  void
  print_1 (int a)
  {
    cout << a << endl;
  }

  void
  print_2 (int a, int b)
  {
    cout << a << " " << b << endl;
  }

  void
  set (int &a, int b)
  {
    a = b;
  }

  struct obj
  {
    obj() {}

    obj (const obj &)
    {
      cout << "obj::obj (const obj &)" << endl;
    }

    void print_1 (int a)
    {
      cout << a << endl;
    }

    void print_2 (int a, int b)
    {
      cout << a << " " << b << endl;
    }
  };

  void
  print_obj (const obj &)
  {
    cout << "print_obj (const obj &)" << endl;
  }

  void
  maximize (int &m, int v)
  {
    if (m < v)
      m = v;
  }
}

int
main ()
{
  bind (&print_1, 1) ();

  bind (&print_1, _0) (2);

  bind (&print_2, _0, 3) (2);

  bind (&print_2, _1, _2) (2, 1, 3);

  cout << "===" << endl;
  int a;
  bind (&set, _0, 8) (ref (a));
  bind (&set, ref (a), 8) ();
  cout << a << endl;
  cout << endl;

  obj o;
  cout << "===" << endl;
  bind (&print_obj, o) ();
  cout << endl;

  cout << "===" << endl;
  bind (&print_obj, _0) (o);
  cout << endl;

  cout << "===" << endl;
  bind (&print_obj, cref (o)) ();
  cout << endl;

  cout << "===" << endl;
  bind (&print_obj, _0) (cref (o));
  cout << endl;

  cout << "===" << endl;
  vector<int> v (5);
  generate (v.begin (), v.end (), rand);
  for_each (v.begin (), v.end (), print_1);
  cout << "---" << endl;

  a = 0;
  for_each (v.begin (), v.end (), bind (&maximize, ref (a), _0));
  cout << a << endl;

  return 0;
}

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: 9a43436d-b46e-4781-89f2-bc521769cb3a
 * End:
 */
