#include "call-traits.h"
#include <iostream>

using namespace std;
using namespace nonstd;

namespace
{
  struct S
  {
    S ()
    {
      cout << "S::S()" << endl;
    }

    S (const S &)
    {
      cout << "S::S(const S &)" << endl;
    }
  };

  void
  print0 (int, S, const S &)
  {
    cout << "print0" << endl;
  }

  void
  print1 (int i, S s, const S &t)
  {
    cout << "print1" << endl;
    print0 (i, s, t);
  }

  void
  print2 (param<int>::type i, param<S>::type s, param<const S &>::type t)
  {
    cout << "print2" << endl;
    print0 (i, s, t);
  }
}

int
main ()
{
  int i;
  S s, t;

  cout << "***" << endl;
  print0 (i, s, t);

  cout << "***" << endl;
  print1 (i, s, t);

  cout << "***" << endl;
  print2 (i, s, t);

  return 0;
}

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: 2e14be45-c533-4207-b840-84f30063ebc8
 * End:
 */
