/*
 * Copyright (C) 2003 Momchil Velikov
 *
 * See file COPYING for license.
 */


#ifndef nonstd__call_traits_h
#define nonstd__call_traits_h 1

#include "misc.h"
#include "type-traits.h"

namespace nonstd
{
  template<typename Tp>
  struct param
  {
    typedef typename add_const<Tp>::type const_type;
    typedef typename add_reference<const_type>::type const_reference_type;

    typedef typename impl::select<(is_primitive<Tp>::value
                                   || is_pointer<Tp>::value),
                                  Tp, const_reference_type>::type type;
  };
}

#endif /* nonstd__call_traits_h */

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: fb8e7b48-8d4b-4ebf-8a18-844a812ab3f2
 * End:
 */
