#include "function.h"
#include <iostream>

using namespace nonstd;
using namespace std;

namespace
{
  void
  hello_world ()
  {
    cout << "Hello, World!" << endl;
  }

  void
  hello_world_1 (int a)
  {
    cout << "Hello, World! " << a << endl;
  }

  void
  hello_world_2 (int a, int b)
  {
    cout << "Hello, World! " << a << " " << b << endl;
  }

  struct goodbye_world
  {
    void print ()
    {
      cout << "Good-bye, World!" << endl;
    }

    void print_1 (int a)
    {
      cout << "Goodbye, World! " << a << endl;
    }

    void print_2 (int a, int b)
    {
      cout << "Goodbye, World! " << a << " " << b << endl;
    }
  };
}

int
main ()
{
  {
    function<void ()> a (&hello_world);
    a ();

    goodbye_world b;
    function<void (goodbye_world *)> c (&goodbye_world::print);
    c (&b);

    function<void (goodbye_world *)> d (c);
    d (&b);

    function<void (int)> e (&hello_world_1);
    e (2);

    function<void (goodbye_world *, int)> f (&goodbye_world::print_1);
    f (&b, 3);

    function<void (goodbye_world *, int)> g (f);
    g (&b, 4);

    function<void (int, int)> h (&hello_world_2);
    h (2, 3);

    function<void (goodbye_world *, int, int)> i (&goodbye_world::print_2);
    i (&b, 3, 4);

    function<void (goodbye_world *, int, int)> j (i);
    j (&b, 4, 5);
  }

  {
    cout << function_traits<function<void (int, int)> >::arity << endl;

    function_traits<function<void (float, int)> >::arg1_type x = 1;

    (function_traits<function<void ()> >::return_type) &x;
  }

  {
    make_function(&hello_world) ();

    goodbye_world b;
    make_function (&goodbye_world::print) (&b);

    make_function (make_function (&goodbye_world::print)) (&b);

    make_function (&hello_world_1) (2);

    make_function (&goodbye_world::print_1) (&b, 3);

    make_function (make_function (&goodbye_world::print_1)) (&b, 4);

    make_function (&hello_world_2) (2, 3);

    make_function (&goodbye_world::print_2) (&b, 3, 4);

    make_function (make_function (&goodbye_world::print_2)) (&b, 4, 5);
  }

  return 0;
}

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: 5388c4b5-487d-485f-9560-fbba79c0cb3b
 * End:
 */
