/*
 * Copyright (C) 2003 Momchil Velikov
 *
 * See file COPYING for license.
 */


#ifndef nonstd__ptr_to_member_h
#define nonstd__ptr_to_member_h 1

#include "function-traits.h"

namespace nonstd
{
  namespace impl
  {
    template<unsigned int arity, typename Obj, typename Fn>
    struct ptr_to_member_helper;

    template<typename Obj, typename Fn>
    struct ptr_to_member_helper<0, Obj, Fn>
    {
      typedef typename function_traits<Fn>::return_type return_type;
      typedef return_type (Obj::* type) (void);
    };

    template<typename Obj, typename Fn>
    struct ptr_to_member_helper<1, Obj, Fn>
    {
      typedef typename function_traits<Fn>::return_type return_type;
      typedef typename function_traits<Fn>::arg0_type arg0_type;
      typedef return_type (Obj::* type) (arg0_type);
    };

    template<typename Obj, typename Fn>
    struct ptr_to_member_helper<2, Obj, Fn>
    {
      typedef typename function_traits<Fn>::return_type return_type;
      typedef typename function_traits<Fn>::arg0_type arg0_type;
      typedef typename function_traits<Fn>::arg1_type arg1_type;
      typedef return_type (Obj::* type) (arg0_type, arg1_type);
    };

    template<typename Obj, typename Fn>
    struct ptr_to_member_helper<3, Obj, Fn>
    {
      typedef typename function_traits<Fn>::return_type return_type;
      typedef typename function_traits<Fn>::arg0_type arg0_type;
      typedef typename function_traits<Fn>::arg1_type arg1_type;
      typedef typename function_traits<Fn>::arg2_type arg2_type;
      typedef return_type (Obj::* type) (arg0_type, arg1_type, arg2_type);
    };

    template<typename Obj, typename Fn>
    struct ptr_to_member_helper<4, Obj, Fn>
    {
      typedef typename function_traits<Fn>::return_type return_type;
      typedef typename function_traits<Fn>::arg0_type arg0_type;
      typedef typename function_traits<Fn>::arg1_type arg1_type;
      typedef typename function_traits<Fn>::arg2_type arg2_type;
      typedef typename function_traits<Fn>::arg3_type arg3_type;
      typedef return_type (Obj::* type) (arg0_type, arg1_type, arg2_type,
                                         arg3_type);
    };
  }


  template<typename Obj, typename Fn>
  struct ptr_to_member
    : public impl::ptr_to_member_helper<function_traits<Fn>::arity, Obj, Fn>
  {
  };
}

#endif /* nonstd__ptr_to_member_h */

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: 967c17d5-e631-40f4-a096-c863403336fa
 * End:
 */
