/*
 * Copyright (C) 2003 Momchil Velikov
 *
 * See file COPYING for license.
 */


#ifndef nonstd__ref_h
#define nonstd__ref_h 1

namespace nonstd
{
  namespace impl
  {
    template<typename T>
    struct ref
    {
      ref (T &ref) : ref_ (ref) {}

      operator T& () { return ref_; }

      T &ref_;
    };

    template<typename T>
    struct cref
    {
      cref (const T &ref) : ref_ (ref) {}

      operator const T& () { return ref_; }

      const T &ref_;
    };
  }


  template<typename T>
  inline impl::ref<T>
  ref (T &r)
  {
    return impl::ref<T> (r);
  }

  template<typename T>
  inline impl::cref<T>
  cref (const T &r)
  {
    return impl::cref<T> (r);
  }
}

#endif /* nonstd__ref_h 1 */

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: e9da28d3-b8f6-4d81-82af-d76e1fa88975
 * End:
 */
