#include "token.h"
#include <iostream>
#include <iterator>

using namespace std;
using namespace nonstd;

namespace
{
  class tokenizer_fn0 : public char_separator_fn<char>
  {
  public:
    tokenizer_fn0 () : char_separator_fn<char> ("-;", "|", 0, true)
    {
    }
  };

  class tokenizer_fn1 : public char_separator_fn<char>
  {
  public:
    tokenizer_fn1 () : char_separator_fn<char> (" \t", ".,;", "\\")
    {
    }
  };

  class tokenizer_fn2 : public char_separator_fn<char>
  {
  public:
    tokenizer_fn2 () : char_separator_fn<char> ("/", 0, "\\")
    {
    }
  };
}

int
main ()
{
  string str0 = ";;Hello|world||-foo--bar;yow;baz|";
  string str1 = "  Hello	 world;\\ alabala";
  string str2 = "/path//to/some\\ file/";

  typedef tokenizer<tokenizer_fn0> string_tokenizer0;
  typedef tokenizer<tokenizer_fn1> string_tokenizer1;
  typedef tokenizer<tokenizer_fn2> string_tokenizer2;

  string_tokenizer0 tok0 (str0);
  string_tokenizer1 tok1 (str1);
  string_tokenizer2 tok2 (str2);

  for (string_tokenizer0::iterator i = tok0.begin (); i != tok0.end(); ++i)
    cout << " <" << *i << '>';
  cout << endl;

  for (string_tokenizer1::iterator i = tok1.begin (); i != tok1.end(); ++i)
    cout << " <" << *i << '>';
  cout << endl;

  for (string_tokenizer2::iterator i = tok2.begin (); i != tok2.end(); ++i)
    cout << " <" << *i << '>';
  cout << endl;

  return 0;
}

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: b8c37f03-5976-4bfe-ba27-6445cc94fa7b
 * End:
 */
