#include "tuple.h"
#include "function.h"
#include <iostream>

using namespace std;
using namespace nonstd;

namespace
{
  void
  hello_world_1 (int a)
  {
    cout << "Hello, World! " << a << endl;
  }

  void
  hello_world_2 (int a, int b)
  {
    cout << "Hello, World! " << a << " " << b << endl;
  }
}

int
main ()
{
  {
    /* ``tuple'' structure.  */
    tuple<int> a;
    a.head = 1;

    tuple<int, int> b;
    b.head = 1;
    b.tail.head = 2;

    tuple<tuple<int, float>, int> c;
    c.head.head = 1;
    c.head.tail.head = 2.0f;
    c.tail.head = 3;

    tuple<tuple<int>, tuple<float> > d;
    d.head.head = 1;
    d.tail.head.head = 2;

    tuple <int, float, double, int> e;
    e.head = 1;
    e.tail.head = 2.0f;
    e.tail.tail.head = 3.0;
    e.tail.tail.tail.head = 4;

    int x = 1;
  }

  {
    /* ``tuple'' construction  */
    tuple<int> a (1);
    a = make_tuple (2);

    tuple<int, int> b (1, 2);
    b = make_tuple (2, 3);

    tuple<tuple<int, float>, int> c (tuple<int, float> (1, 2.0f), 3);
    c = make_tuple (make_tuple (2, 3.0f), 4);

    tuple<tuple<int>, tuple<float> > d (tuple<int>(1), tuple<float>(2.0f));
    d = make_tuple (make_tuple (2), make_tuple (3.0f));

    tuple <int, float, double, int> e (1, 2.0f, 3.0, 4);
    e = make_tuple (2, 3.0f, 4.0, 5);

    int x = 1;
  }

  {
    /* ``nth_type''  */

    nth_type<0, tuple<int> >::type a = 1;

    nth_type<1, tuple<int, float> >::type b = 1.0f;

    nth_type<0, tuple<tuple<int, float>, int> > ::type c =
      make_tuple (1, 2.0f);

    nth_type<1, tuple<tuple<int>, tuple<float> > >::type d =
      make_tuple(1.0f);

    nth_type<2, tuple <int, float, double, int> >::type e = 3.0;

    int x = 1;
  }

  {
    /* ``nth_elt''  */

    tuple<int> a;
    nth_elt<0> (a) = nth_elt<0> (make_tuple (1));

    tuple<int, int> b (1, 2);
    nth_elt<1> (b) = nth_elt<0> (b);

    tuple<int, float, int> c (1, 2.0f, 3);
    nth_elt<1> (c) = nth_elt<2> (c);

    tuple<tuple<int>, tuple<float> > d;
    nth_elt<0> (nth_elt<1> (d)) = nth_elt<0> (nth_elt<0> (d));

    tuple <int, float, double, int> e (1, 2.0f, 3.0, 4);
    nth_elt<2> (e) = nth_elt<1> (e);

    int x = 1;
  }

  {
    /* ``call'' */

    call (hello_world_1, make_tuple (1));

    call (hello_world_2, make_tuple (1, 2));

    function<void (int)> f (&hello_world_1);
    call (f, make_tuple (1));

    function<void (int, int)> g (&hello_world_2);
    call (g, make_tuple (1, 2));
  }

  return 0;
}

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: fc1a01fb-e83b-4449-9627-96b1d725be0d
 * End:
 */
