#include "type-traits.h"
#include <iostream>

using namespace std;
using namespace nonstd;

namespace
{
  struct S
  {
    void print ()
    {
      cout << "S" << endl;
    }

    void print () const
    {
      cout << "const S" << endl;
    }
  };

  void
  print (int)
  {
    cout << "int" << endl;
  }

  void
  print (int *)
  {
    cout << "int *" << endl;
  }

  void
  print (S)
  {
    cout << "S" << endl;
  }

  void
  print (S *)
  {
    cout << "S *" << endl;
  }

  void
  print_ref (S &)
  {
    cout << "S &" << endl;
  }
}

int
main ()
{
  print (int());

  S().print ();

  //  (add_const<S>::type ()).print ();

  //  (add_const<const S>::type ()).print ();

  //  (remove_const<S>::type ()).print ();

  //  (remove_const<const S>::type ()).print ();

  print (add_pointer<S>::type ());

  print (remove_pointer<S *>::type ());

  print (add_pointer<S &>::type ());

  S s;
  print_ref (remove_pointer<S &>::type (s));

  print_ref (add_reference<S>::type (s));

  print_ref (add_reference<S &>::type (s));

  print (remove_reference<S>::type ());

  print (remove_reference<S &>::type ());

  return 0;
}

/*
 * Local variables:
 * mode: C++
 * indent-tabs-mode: nil
 * arch-tag: cac03589-1987-4e0b-94eb-40dbf53d5729
 * End:
 */
